local addonName, addonTable = ...;

NISConfig = {

}

function NISConfig.OnLoad(panel)
	panel.name = "Night Illusion (v" .. GetAddOnMetadata("NightIllusion", "Version")..")";
	panel.okay = function (self) NISConfig.Close(); end;
	panel.cancel = function (self) NISConfig.CancelOrLoad(); end;
    panel.default = function (self) NISConfig.Defaults(); end;
    panel.refresh = function (self) NISConfig.Refresh(); end;
	
	InterfaceOptions_AddCategory(panel);
end

function NISConfig.Close()
    local frame = NIConfigUIFrame.settings;
    NISettings:SetStartTime(NIDisplay:Calc24H( frame.nightStart:GetText() ))
    NISettings:SetEndTime(NIDisplay:Calc24H( frame.nightEnd:GetText() ))
    
    NISettings:SetMinAlpha( frame.alphaMin:GetValue() / 100 )
    NISettings:SetMaxAlpha( frame.alphaMax:GetValue() / 100 )
    
    NISettings:SetCombatSafe( frame.combat:GetChecked() )
    
    NISettings:SetButton( frame.minimap:GetChecked() )
    
    local scaleF = NIConfigUIFrame.scaling;
    NISettings:SetLightPosition(scaleF.posX:GetValue(), scaleF.posY:GetValue())
    NISettings:SetLightScaling(scaleF.scaleX:GetValue(), scaleF.scaleY:GetValue())
    
    NISConfig.Update()
end

function NISConfig.Update()
    NIButton:UpdateButton()
end

function NISConfig.CancelOrLoad()
	-- NICore:PrintD("NIS Cancel/Load");
end

function NISConfig.Defaults()    
    NISettings:GetDefault();
    NISConfig.Update()
end

function NISConfig.Refresh()
    local startTime = NIDisplay:PrettyTime(NISettings:GetStartTime())
    local endTime = NIDisplay:PrettyTime(NISettings:GetEndTime())
    
    local frame = NIConfigUIFrame.settings;
    
    frame.nightStart:SetText(startTime);
    frame.nightStart:SetCursorPosition(0)
    frame.nightEnd:SetText(endTime);
    frame.nightEnd:SetCursorPosition(0)
    
    frame.alphaMin:SetValue(NISettings:GetMinAlpha() * 100);
    frame.alphaMax:SetValue(NISettings:GetMaxAlpha() * 100);
    
    frame.combat:SetChecked(NISettings:IsCombatSafe());
    
    frame.minimap:SetChecked(NISettings:IsButtonShown());
    
    local scaleFrame = NIConfigUIFrame.scaling;
    local posX, posY = NISettings:GetLightPosition();
    local scaleX, scaleY = NISettings:GetLightScaling();
    scaleFrame.posX:SetValue(posX);
    scaleFrame.posY:SetValue(posY);
    scaleFrame.scaleX:SetValue(scaleX);
    scaleFrame.scaleY:SetValue(scaleY);
    
end
function NISConfig.UpdateLight()
    -- local f = NIConfigUIFrame.scaling;
    
    -- NISettings:SetLightPosition(f.posX:GetValue(), f.posY:GetValue())
    -- NISettings:SetLightScaling(f.scaleX:GetValue(), f.scaleY:GetValue())
    
    NIDisplay:RepositionLight();
    NIDisplay:RescaleLight();
end